/*
 * Helpers to convert between coordinates system.
 *
 * Dependencies:
 *     - Math.frag
 */

#define SEAM_THRESHOLD 0.001

/**
 * This method performs an equirectangular projection, i.e.,
 * projects a 3D cartesian direction on a 2D cartesian coordinate system.
 *
 * @param dir The **normalized** coordinate to project
 * @returns The 2D projected direction
 */
vec2 cartesianToEquirectangular(vec3 dir) {
    float u = atan(dir.z + EPSILON_F, dir.x + EPSILON_F) * RECIPROCAL_PI2 + 0.5;
    float v = asin(dir.y) * RECIPROCAL_PI + 0.5;
    return vec2(u, v);
}
